#include <htc.h>
#include "ad.h"

void ad_init(void)
{
	ADCON1 = 0b00001101;		// Ref = VDD-VSS, Use AN0, AN1
	ADCON2 = 0b00000111;		// Left justified, 0TAD, FRC
}

unsigned char ad_getvalue(unsigned char ch)
{
	char c;
	ADCON0 = 0b00000001 + (ch << 2);
	for(c=0; c<40; c++) continue;		// Sampling timer
	ADCON0 |= 0b00000010;
	while(ADCON0 & 0b00000010) continue;
	ADCON0 = 0;						// Disable A/D
	return ADRESH;
}

unsigned char ad_getsw(void)
{
	char c;
	ADCON0 = 0b00000001;				// Ch=0, Enable AD
	for(c=0; c<40; c++) continue;		// Sampling timer
	ADCON0 |= 0b00000010;
	while(ADCON0 & 0b00000010) continue;
	ADCON0 = 0;						// Disable AD
	if(ADRESH > 200) return AD_SW4;		// value ~ 255
	if(ADRESH > 120) return AD_SW3;		// value ~ 143
	if(ADRESH >  80) return AD_SW2;		// value ~  95
	if(ADRESH >  50) return AD_SW1;		// value ~  71
	return AD_NOSW;
}
