#ifndef __GPS_H__
#define __GPS_H__

struct gps_daytime_st {
	unsigned char year;		// year (last 2 digits)
	unsigned char mon;		// month
	unsigned char day;		// day
	unsigned char hour;		// hour
	unsigned char min;		// min
	unsigned char sec;		// sec
};

struct gps_coord_st {
	char  polarity;	// N=1 S=0 / E=1 W=0
	short deg;		// Degree
	short min;		// Minute
	short submin;		// Subminute (resolution = 0.0001)
};

struct gps_meter_st {
	short meter;
	short submeter;
};

struct gps_info_st {
	struct gps_daytime_st	daytime;
	struct gps_coord_st	latitude;
	struct gps_coord_st	longitude;
	struct gps_meter_st	altitude;
	struct gps_meter_st	speed;
	struct gps_meter_st	hdop;
	unsigned char		state;
	unsigned char		numsat;
	unsigned long		numupdate;
	unsigned long		numerr;
};

extern struct gps_info_st gps_info;

// Function prototypes
void gps_init(void);
void gps_setwgs84(void);
void gps_isr(void);

#endif // __GPS_H__
