#include "i2c.h"
#include "lcd.h"

#define LCDADR 0b0111110		// I2C LCD Address

static void wait_ms(long x)
{
	long c;
	for(c = 0; c < x * 100; c++) continue;
}

void lcd_cmd(unsigned char data)
{
	i2c_start(LCDADR);
	i2c_write(0x00);
	i2c_write(data); // function set
	i2c_stop();
}

void lcd_init(void)
{
	// RgXg̐ݒ
	unsigned char contrast = 0b100111;	// 3.0V lグƔZȂ܂B
									// 2.7Vł0b111000炢ɂĂBB
									// RgXg͓ddCxɂ肩Ȃω܂Bۂ̉t݂ĒĂB
	i2c_init();
	wait_ms(30);
	lcd_cmd(0b00111000);	// function set
	lcd_cmd(0b00111001);	// function set
	lcd_cmd(0b00010100);	// interval osc
	lcd_cmd(0b01110000 | (contrast & 0xF)); // contrast Low
	lcd_cmd(0b01011100 | ((contrast >> 4) & 0x3)); // contast High/icon/power
	lcd_cmd(0b01101100);	// follower control
	wait_ms(40);
	lcd_cmd(0b00111000);	// function set
	lcd_cmd(0b00001100);	// Display On
	lcd_cmd(0b00000001);	// Clear Display
	wait_ms(2);			// Clear Display͒ǉEFCgKv

	// ACR΍@ȂR}hł͕\Ȃ̂ŁAŏĂяo
	lcd_cmd(0b00111001);	// R}h
	lcd_cmd(0b01000000);	// ACR̈̃AhXݒ
	lcd_putc(0b00000000);	// ACRf[^
}

void lcd_putc(char ch)
{
	i2c_start(LCDADR);
	i2c_write(0b01000000);
	i2c_write(ch);
	i2c_stop();
}

void lcd_puts(const char *s)
{
	while(*s){
		lcd_putc(*s++);
	}
}

void lcd_clear(void)
{
	lcd_cmd(0b00000001);
	wait_ms(2);
}

void lcd_puticon(unsigned char icon, unsigned char value)
{
	lcd_cmd(0b00111001);

	switch(icon){
	case ICON_ANT:
		lcd_cmd(0b01000000 + 0);
		if(value == 0){
			lcd_putc(0b00000000);
		} else {
			lcd_putc(0b00010000);
		}
		break;

	case ICON_BAT:
		lcd_cmd(0b01000000 + 0x0d);
		switch(value){
		case 0:
			lcd_putc(0b00000010);
			break;
		case 1:
			lcd_putc(0b00010010);
			break;
		case 2:
			lcd_putc(0b00011010);
			break;
		case 3:
		default:
			lcd_putc(0b00011110);
			break;
		}
		break;
	case ICON_SCSI:
		lcd_cmd(0b01000000 + 0x06);
		if(value == 0){
			lcd_putc(0b00000000);
		} else {
			lcd_putc(0b00010000);
		}
		break;

	default:
		break;
	}
}
